import { TextPropertyEditor as SubstanceTextPropertyEditor } from 'substance'

class TextPropertyEditor extends SubstanceTextPropertyEditor {
// Substance TextPropertyEditor Extends directly Surface and we don't oerwrite Surface. In our CantainerEditor we overwrite
// TextInput to enbale TrackChanges. So if trackChanges is on We want to execute onTextInput From ContainerEditor
  onTextInput (event) {
    if (!this.isTrackChangesOn()) {
      return super.onTextInput(event)
    }

    let surface = this.getSurface()
    if (!surface) return
    return surface.onTextInput(event)
  }

  onTextInputShim (event) {
    if (!this.isTrackChangesOn()) {
      return super.onTextInputShim(event)
    }

    let surface = this.getSurface()
    if (!surface) return
    return surface.onTextInputShim(event)
  }

  _handleDeleteKey (event) {
    // If isloated note has no content and you keep pressing backspace,
    // it gets deleted.
    const selection = this.editorSession.getSelection()
    if (selection.start.offset === 0 && selection.end.offset === 0) {
      super.onTextInputShim(event)
      return super.onTextInput(event)
    }

    if (!this.isTrackChangesOn()) {
      return super._handleDeleteKey(event)
    }

    let surface = this.getSurface()
    if (!surface) return
    return surface._handleDeleteKey(event)
  }

  _handleSpaceKey (event) {
    if (!this.isTrackChangesOn()) {
      return super._handleSpaceKey(event)
    }

    let surface = this.getSurface()
    if (!surface) return
    return surface._handleSpaceKey(event)
  }

  isTrackChangesOn () {
    return this.context.editor.props.trackChanges
  }

  getSurface () {
    const containerId = this.getContainerId()
    return this.context.surfaceManager.getSurface(containerId)
  }

  getContainerId () {
    return this.context.editor.props.containerId
  }
}

export default TextPropertyEditor
